#!/usr/bin/perl
#IndelChecker.pl
use Statistics::Basic qw(:all);
use List::UtilsBy qw(extract_by);
use warnings; 
use strict;


print "Please specify mutation analysis file:\n";
my $mut = <STDIN>;
chomp $mut;
$mut =~ s/"|'//gi;
open (MUT, "<", $mut) or die "couldn't open file $mut for writing:$!\n";
my @mutlines = (<MUT>);
close MUT;
shift @mutlines;
chomp @mutlines;

my $analysis = $mut;
$analysis =~ s/MutationAnalysis/IndelAnalysis/i;
if ($analysis eq $mut) {
	print "problem in filename: overwrite aborted\n";
	die;
}

open (ANALYSIS, ">", $analysis) or die "couldn't open file $analysis for writing:$!\n";

my @insertions;
my @deletions;
my @insertpositions;
my @deletepositions;

print ANALYSIS  "Length/Position,";
for (my $x = 1; $x<=60; $x++){
	$insertpositions[$x]=0;
	$deletepositions[$x]=0;
	$insertions[$x] = 0;
	$deletions[$x] = 0;
	my $n = $x;
	print ANALYSIS "$n,";
}



	
	
my @geneinsertions;
my @genedeletions;

my $insertcount = 0;
my $deletecount = 0;
	
foreach my $mutline (@mutlines) {
	my @split = split/,/,$mutline;
	
	
	if ($split[9]) {
		my $inserttotal;
		my @insertsplit = split/;/,$split[9];
		foreach my $in (@insertsplit) {
			$insertcount++;
			my @explode = split/:/,$in;
			my $length = $explode[3];
			if ($length > 60) {
				$length = 60;
			}
			$inserttotal+= $length;
			$insertions[$length]++;
			$insertpositions[$explode[1]]++;

		}
		if ($inserttotal > 60) {
			$inserttotal = 60;
		}
		push @geneinsertions, $inserttotal;
	} else {
		push @geneinsertions, "0";
	}
	
	#+:1:37:37;
	#-:0:0:54;
	
	if ($split[10]) {
		my $deletetotal;
		my @deletesplit = split/;/,$split[10];
		foreach my $de (@deletesplit) {
			$deletecount++;
			my @explode = split/:/,$de;
			my $length = $explode[3];
			if ($length > 60) {
				$length = 60;
			}
			$deletetotal+=$length;
			
			$deletions[$length]++;
			$deletepositions[$explode[1]+1]++;
		}
		if ($deletetotal > 60) {
			$deletetotal = 60;
		}		
		push @genedeletions, $deletetotal;			
	} else {
		push @genedeletions, "0";
	}
}
print ANALYSIS "\nInsertion Sizes,";
for (my $x = 1; $x<=60; $x++){
	print ANALYSIS $insertions[$x] . ",";
}
print ANALYSIS "\nDeletion Sizes,";
for (my $x = 1; $x<=60; $x++){
	print ANALYSIS $deletions[$x] . ",";
}

print ANALYSIS "\nInsertion Positions,";
for (my $x = 1; $x<=60; $x++){
	print ANALYSIS $insertpositions[$x] . ",";
}
print ANALYSIS "\nDeletion Positions,";
for (my $x = 1; $x<=60; $x++){
	print ANALYSIS $deletepositions[$x] . ",";
}
print ANALYSIS "\n\n";
print ANALYSIS "$insertcount total insertions\n";
print ANALYSIS "$deletecount total deletions\n";


print ANALYSIS "\n\n";
print ANALYSIS "\nIndividual Gene Analysis\n";
my $n = 0;
foreach my $gene (@geneinsertions) {
	print ANALYSIS "$gene,$genedeletions[$n]\n";
	$n++;
}



