#!/usr/bin/perl
#SNPchecker-mature.pl
use Statistics::Basic qw(:all);
use List::UtilsBy qw(extract_by);
use warnings; 
use strict;

print "Please specify mutation analysis file:\n";
my $mut = <STDIN>;
chomp $mut;
$mut =~ s/"|'//gi;
open (MUT, "<", $mut) or die "couldn't open file $mut for writing:$!\n";
my @mutlines = (<MUT>);
close MUT;
shift @mutlines;
chomp @mutlines;


my $analysis = $mut;
$analysis =~ s/(MutationAnalysis|fixedMature)/SNPAnalysis/i;
if ($analysis eq $mut) {
	print "problem in filename: overwrite aborted\n";
	die;
}
open (ANALYSIS, ">", $analysis) or die "couldn't open file $analysis for writing:$!\n";





if ($analysis eq $mut) {
	print "problem in filename: overwrite aborted\n";
	die;
}
open (ANALYSIS, ">", $analysis) or die "couldn't open file $analysis for writing:$!\n";
my $conserved = 0;
my $nonconserved = 0;
my @positions;
print ANALYSIS  "Position Analysis,";
for (my $x = 0; $x<=59; $x++){
	$positions[$x] = 0;
	my $n = $x+1;
	print ANALYSIS "$n,";
}

print ANALYSIS "\n";
my %class;

my @genes;
my %snpinsert;
my %snpdelete;

my @aminoacids = qw(A C D E F G H I K L M N P Q R S T V W Y);
foreach my $acid (@aminoacids) {		#keeps track of amino acid insertions/deletions/SNPs
		$snpinsert{$acid} = 0; 
		$snpdelete{$acid} = 0; 
}
	
foreach my $mutline (@mutlines) {
	my @split = split/,/,$mutline;
	unless ($split[5]) {
		my $snpscalar = 0;
		push @genes, $snpscalar;
		next;
	}
	my @snpsplit = split/;/,$split[5];
	my $snpscalar = scalar @snpsplit;
	push @genes, $snpscalar;

	foreach my $snp (@snpsplit) {
		my @explode = split/:/,$snp;
		$positions[$explode[0]]++;
		$snpinsert{$explode[1]}++;
		$snpdelete{$explode[2]}++;
		if ($explode[3] =~ m/N/i) {
			$nonconserved++;
			my $join = "$explode[5]$explode[4]";
			if ($class{$join}) {
				$class{$join}++;
			} else {
				$class{$join} = 1;
			}
		} else {
			$conserved++;
		}
	}
}
print ANALYSIS ",";
for (my $x = 0; $x<=59; $x++){
	print ANALYSIS "$positions[$x],";
}
print ANALYSIS "\n\n";
print ANALYSIS "Conserved,$conserved\n";
print ANALYSIS "Nonconserved,$nonconserved\n\n";



print ANALYSIS "INSERTIONS\n";
foreach my $acid (@aminoacids) {
	print ANALYSIS "$acid,";
}
print ANALYSIS "\n";
foreach my $acid (@aminoacids) {
	print ANALYSIS $snpinsert{$acid} . ",";
}
print ANALYSIS "\n\n";

print ANALYSIS "DELETIONS\n";
foreach my $acid (@aminoacids) {
	print ANALYSIS "$acid,";
}
print ANALYSIS "\n";
foreach my $acid (@aminoacids) {
	print ANALYSIS $snpdelete{$acid} . ",";
}
print ANALYSIS "\n\n";


foreach my $key (keys %class) {
	print ANALYSIS "$key,$class{$key}\n"; 
}

print ANALYSIS "\n\n";


print ANALYSIS  "Individual Gene Analysis\n";
foreach my $gene (@genes) {
	print ANALYSIS $gene . "\n";
}


close ANALYSIS;
