#!usr/bin/perl
#blast4040referencer.plx
use warnings;
use strict;

#Custom program designed to reference a dataset of BLAST hits and look for hits with greater than 40% length and 40% identity
	#input: need to have the query length defined for each query ID
	#input: need to have at least "length" and "pident" defined in the BLAST file.
	

print "Please indicate BLAST file to read from: \n";
my $file = <STDIN>;
chomp $file;
$file =~ s/"//g;

print "Please indicate subject dataset for this BLAST file: \n";
my $subject = <STDIN>;
chomp $subject;
$subject =~ s/"//g;

open (FILE, "<", $file) or die "Couldn't open file $file for reading: $!";
my @lines = <FILE>;
close FILE;
	

my @matches;


my $current = '';

foreach my $line (@lines) {
	(my $header) = ($line =~ m/(^\w{9}\d*)/);
	if ($header eq $current) {
		next;
	}
	else {
		$current = $header;
		(my $number) = ($line =~ m/(\d+\.?\d*)$/);
		if ($number > 99) {
			(my $mdp) = ($line =~ m/(,MDP\d*,)/);
			$mdp =~ s/,//g;
			
			push @matches, $mdp;
			#if the number is more than 99%, add to "match" list to redact from subject dataset
		}
		else {
		next;
		#if number is less than 99%, skip entirely.
		}
	}
}
my $scalar = scalar @matches;
print "I found $scalar shared headers in the subject database.\n";


open (SUBJECT, "<", $subject) or die "couldn't open file $subject for reading: $!\n";
my @subjectlines = <SUBJECT>;

close SUBJECT;

my @headers = grep(/(^>\w{9}\d*)/, @subjectlines);
chomp @headers;
my @seqs = grep(/^\w/, @subjectlines);
chomp @seqs;
		
my %zips;
@zips{@headers} = @seqs;




my $scalarzips = scalar(keys %zips);
print "There are $scalarzips elements left before redaction\n";
my $scalararray = scalar @headers;
print "There are $scalararray elements in the headers\n";

my $test = "testrunVelascoChristian.txt";
open (TEST, ">", $test) or die "couldnt' open file $test for writing: $!\n";


foreach my $testheader (@headers) {
	print TEST $testheader . "\n";
	print TEST $zips{$testheader} . "\n";
}


#redact matched hits
foreach my $match (@matches) {
	my $fastaheader = ">$match";
	delete($zips{$fastaheader});
}


my $unique = "$subject-UNIQUE.fasta";
open (UNIQUE, ">", $unique) or die "couldnt' open file $unique for writing: $!\n";


my @remaining = keys %zips;

my $scalarremaining = scalar @remaining;
print "There are $scalarremaining elements left after redaction\n";
#print out the remaining seqs

foreach my $remaining (@remaining) {
	print UNIQUE $remaining . "\n";
	print UNIQUE $zips{$remaining} . "\n";
	
}

