#!usr/bin/perl
#remarkbesthits.plx
use warnings;
use strict;

#program designed to extract BEST single BLAST results from .csv files in a directory and make rowlist, collist, and scorelist files for each.

#program needs:
	#for each of 78+ blastP pairwise comparison csv's,
		#create "BEST" run
	#will create TWO initial runs	
		#one with forward BLAST 
		#another with reciprocal BLAST
			#reciprocol might pick up ones that were ingored the first time around because they weren't prioritized in the ordering
			#for instance, a species with 5 sequences in a COG might get a BLAST hit of only 1 sequence in another, even though that species might ALSO have 5. 
	
	

print "Please input index file for the possible pairs: \n";
my $index = <STDIN>;
chomp $index;
$index =~ s/"//gi;

open (INDEX, "<", $index) or die "Couldn't open file $index for reading: $!\n";
my @index = <INDEX>;
chomp @index;
close INDEX;
	
	
	
#program input: directory of BLAST datafiles in .csv format
	#ex: "Artha_cTP533, Frave_xTP49992, 3083.0";
	
print "Please indicate directory of BLAST files to read from: \n";
my $directory = <STDIN>;

chomp $directory;
$directory =~ s/"//g;
chdir $directory;

if (-d $directory) {
	print "Reading from directory $directory.\n";
}	else {
	print "$directory is not a directory! \n";
	die;
}


print "Starting at: " . localtime . "\n";




#foreach my file
	#foreach my forward/reverse	
		#extract BEST hits

	
my @order = (0,1);

my @blasts;	
foreach my $indexline (@index) {
	foreach my $order (@order) {
		#this part of the code looks at the index file to determine which genome needs to come first (forward or reciprocal). 
		my @pair = split /\t/, $indexline;
		
		my $csvfile = "$pair[$order]\_$pair[$order-1].csv";
			#if $order is 1, it will go "1,0" (reciprocal)
			#if $order is 0, it will go "0,-1" (forward)
			#remember that in arrays, using a negative starts from the end of the array, so in this case -1 is equivalent to 1.
		open (FILE, "<", $csvfile) or die "Couldn't open file $csvfile for reading: $!\n";

		
		my $out = $csvfile;		
		$out =~ s/.csv//gi;		#remove ".csv" from filename
		my $fr;
			if ($order == 0) {
				$fr = "forward";
			} else {
				$fr = "reverse";
			}
		$out = "$out-BestHit-$fr.csv";
		push @blasts, $out;
		open (OUT, ">", $out) or die "couldn't open $out for writing: $!\n";
		my $last = '';
		while (<FILE>) {
			(my $query) = $_ =~ m/(^\w{9}\d*)/;
			if ($query eq $last) {
				next;
			} else {
				print OUT $_;
				$last = $query;				
			}
		}
		close FILE;
		close OUT;
	}
	
	#finishes current .csv file
}
#finishes all 100 runs of current directory		
		

print "Best Hit extraction complete. Starting file splitting at: " . localtime . "\n";
		
#here begins the splitting function
#Splits all .csv files that have been created into three different .csv files

my $fwddirectory = "$directory\\Forward\\Split";
my $revdirectory = "$directory\\Reverse\\Split";
print "\nSplitting files at: " . localtime . "\n";
mkdir $fwddirectory;
mkdir $revdirectory;

foreach my $blast (@blasts) {
	chdir $directory;
	open (BLAST, "<", $blast) or die "couldn't open file $blast for splitting: $!\n";
	(my $query_subject) = $blast =~ m/(\w{5}_\w{5})/;

	my @blastlines = <BLAST>;
	close BLAST;
	
	if ($blast =~ m/forward/g) {
		chdir $fwddirectory;
	}	else {
		chdir $revdirectory;
	}

	my $rowlist = "rowlist_$query_subject.csv";
	my $collist = "collist_$query_subject.csv";
	my $scorelist = "scorelist_$query_subject.csv";
	open (ROWLIST, ">", $rowlist) or die "couldn't open $rowlist for writing! $!";
	open (COLLIST, ">", $collist) or die "couldn't open $collist for writing! $!";
	open (SCORELIST, ">", $scorelist) or die "couldnt' open $scorelist for writing! $!";
	
	foreach my $blastline (@blastlines) {

		(my $queryname) = $blastline =~ m/(^\w{9}\d*)/;

		print ROWLIST "$queryname";
		print ROWLIST "\n";
		(my $subjectname) = $blastline =~ m/(,\w{9}\d*,)/;
		$subjectname =~ s/,//g;

		print COLLIST "$subjectname";
		print COLLIST "\n";
		(my $score) = $blastline =~ m/(\d*$)/;

		print SCORELIST "$score";
		print SCORELIST "\n";
	}
}


