#!/usr/bin/perl
#blastcsvminer.pl
use warnings;
use strict;

#this program is intended to clean up BLAST results to return JUST the headers of each BLAST pair. 

#open directory to read from:
print "Please indicate directory to read from: \n";
my $directory = <STDIN>;
chomp $directory;
$directory =~ s/"//g;


if (-d $directory) {
	print "Reading from directory $directory.\n";
}	else {
	print "$directory is not a directory! \n";
	die;
}

print "What identity threshold do you want between 0 and 1? \n";
my $id = <STDIN>;
chomp $id;
print "What coverage threshold (query/subject) do you want?\n";
my $cov = <STDIN>;
chomp $cov;

chdir $directory;
opendir(DH, $directory);
my @files = readdir(DH);
closedir(DH);
my @csv = grep(m/.csv$/, @files);

foreach my $file (@csv) {
	open (FILE, "<", $file) or die "couldn't open file $file for reading: $!\n";
	my $fixed = $file;
	$fixed =~ s/.csv$/ID$id-COV$cov-mined.csv/i;

	open (FIXED, ">", $fixed) or die "couldn't open file $fixed for writing: $!\n";
	while (<FILE>) {
		my $line = $_;
		chomp $line;
		my @splits = split/,/, $line;
		my $identity = $splits[2];
		my $coverage = $splits[6];
		if (($identity >= $id) && ($coverage >=$cov)) {
			print FIXED $line . "\n";
		}
	}
	close FILE;
	close FIXED;
}