#!/usr/bin/perl
#consensuspicker.pl
use warnings;
use strict;
use List::UtilsBy qw(extract_by);

#This program is designed to parse results of the "uniqueclusterconsensus3.pl" program 
	#will select for clusters that have at least 3 species represented.

print "Please indicate CONSENSUS unique cluster file:\n";
my $input = <STDIN>;
chomp $input;
$input =~ s/"|'//gi;

open (INPUT, "<", $input) or die "couldn't open file $input for reading: $!\n";
my @lines = <INPUT>;
chomp @lines;
shift @lines;

my $out = $input;
$out =~ s/.tab/_PARSED.tab/;
open (OUT, ">", $out) or die "couldn't open file $out for writing: $!\n";

my $rejected = $input;
$rejected =~ s/.tab/_REJECTS.tab/;
open (REJECT, ">", $rejected) or die "couldn't open file $rejected for writing: $!\n";

foreach my $line (@lines) {
	my @tab = split/\t/, $line;	
	
		my $blast = $tab[5];
	my @headers;
	if ($blast) {
		@headers = split/,/,$blast;
	}
	my $uclust = $tab[9];
	my @uclusts;
	if ($uclust) {
		@uclusts = split/,/,$uclust;
	}
	push @headers, @uclusts;
	foreach my $headertemp (@headers) {
		$headertemp =~ s/\s//g;
		$headertemp =~ s/_Seq/_seq/;
	}
	@headers = UNIQUE(@headers);

	my @seqs = @headers;
	foreach my $seq (@seqs) {
		$seq =~ s/_\S+$//;
	}
	@seqs = UNIQUE(@seqs);
	my $scalar = scalar @seqs;
	if ($scalar > 2) {
		my $join = join(',',@headers);
		print OUT $tab[0] . "\t" . $tab[1] . "\t" . $tab[2] . "\t" . $tab[6] . "\t" . $join . "\n"; 	#print out BLAST header, UCLUST header, condensed cluster contents 
	} else {
		my $join = join(',',@headers);
		print REJECT $tab[0] . "\t" . $tab[1] . "\t" . $tab[2] . "\t" . $tab[6] . "\t" . $join . "\n"; 	#print out BLAST header, UCLUST header, condensed cluster contents 
		}
}


#Unique Cluster Name	.	Unique Plastidial Headers	.	BLAST0.90 Cluster ID	.	BLAST0.90 Plastidial Headers	.	BLAST0.90 Cluster Overlap	.	BLAST0.90 Total Headers		.	UCLUST0.90 Cluster ID	.	UCLUST0.90 Plastidial Headers	.	UCLUST0.90 Cluster Overlap	.	UCLUST0.90 Total Headers



sub UNIQUE {
	my %seen;
    grep !$seen{$_}++, @_;
	my @unique = keys (%seen);
	my $scalar = scalar @_;
	return @unique;
}