#!/bin/usr/perl
#majorityGO.pl
use List::UtilsBy qw(extract_by);
use warnings;
use strict;


#New functionality needed:
	#-accept all hits greater than 10%
	#-if GO terms for each category are not found at >10% frequency, trim to the Arabidopsis, Rice, and Brachypodium
		#-accept GO terms greater than 10% for those. 


print "Please input cluster CSV file to read: \n";
my $cluster = <STDIN>;
chomp $cluster;
$cluster =~ s/"|'//gi;

open (CLUSTER, "<", $cluster) or die "couldn't open file $cluster for reading: $!\n";
my $out = $cluster;
$out =~ s/.csv/_MajorityGO.csv/gi;
open (OUT, ">", $out) or die "couldn't open file $out for writing: $!\n";
my $newout = "test.csv";
open (NEWOUT, ">", $newout) or die "couldn't open file $newout for writing: $!\n";
while (<CLUSTER>) {
	my $line = $_;
	chomp $line;
	my @linesplit = split/,/,$line;
	my $header = shift @linesplit;
	my @components;
	my @functions;
	my @processes;
	my %lookup;
	my $clusternumber = scalar @linesplit;
	
	my %condensedlookup;

	
	foreach my $sequence (@linesplit) {
		my @seqsplit = split/\t/,$sequence;
		my @gosplit = split/;/,$seqsplit[1];
		if ($gosplit[0] =~ m/-/){
			next;
		}
		my $condensed = 0;
		if ($sequenceheader =~ m/artha|bradi|orysa/gi) {
			$condensed = 1;
		}	
		foreach my $go (@gosplit) {
			my @subsplit = split//,$go;
			my $category = shift @subsplit;
			shift @subsplit; #remove colon
			my $gojoin = join('',@subsplit);
			if ($category eq "C") {
				push @components, $gojoin;
				if ($lookup{$gojoin}) {
					$lookup{$gojoin}++;
					if ($condensed) {
						$condensed{$gojoin}++;
					}
				} else {
					$lookup{$gojoin} = 1;
					if ($condensed) {
						$condensed{$gojoin} = 1;
					}				
				}
				
			}
			if ($category eq "F") {
				push @functions, $gojoin;
				if ($lookup{$gojoin}) {
					$lookup{$gojoin}++;
					if ($condensed) {
						$condensed{$gojoin}++;
					}
				} else {
					$lookup{$gojoin} = 1;
					if ($condensed) {
						$condensed{$gojoin} = 1;
					}				
				}
			}
			if ($category eq "P") {
				push @processes, $gojoin;
				if ($lookup{$gojoin}) {
					$lookup{$gojoin}++;
					if ($condensed) {
						$condensed{$gojoin}++;
					}
				} else {
					$lookup{$gojoin} = 1;
					if ($condensed) {
						$condensed{$gojoin} = 1;
					}				
				}
			}
		}
	}
	
	if (scalar @components == 0) {
		#trigger condensed check
	}
	if (scalar @functions == 0) {
		#trigger condensed check
	}
	if (scalar @processes == 0) {
		#trigger condensed check
	}	
	my $highcomponent = 0;
	my $highfunction = 0;
	my $highprocess = 0;
	
	my @keepcomp;
	my @keepfunc;
	my @keepproc;
	
	foreach my $comp (@components) {
		my $number = $lookup{$comp};
		if ($number > ($clusternumber/10)) {
			push @keepcomp, $comp;
		} else {
			next;
		}
	}
	foreach my $func (@functions) {
		my $number = $lookup{$func};
		if ($number > ($clusternumber/10)) {
			push @keepfunc, $func;
		} else {
			next;
		}	
	}
	foreach my $proc (@processes) {
		my $number = $lookup{$proc};
		if ($number > ($clusternumber/10)) {
			push @keepproc, $proc;
		} else {
			next;
		}	
	}
	@components = UNIQUE(@components);
	@functions = UNIQUE(@functions);
	@processes = UNIQUE(@processes);
	
	foreach my $comp (@components) {
		my $compnumber = $lookup{$comp}/$clusternumber;
		print NEWOUT "$header,C,$comp,$compnumber\n"
	}
		
	foreach my $func (@functions) {
		print NEWOUT "$header,F,$func,$lookup{$func}\n"
	}
	foreach my $proc (@processes) {
		print NEWOUT "$header,P,$proc,$lookup{$proc}\n"
	}	

}

sub UNIQUE {
	my %seen;
    grep !$seen{$_}++, @_;
	my @unique = keys (%seen);
	my $scalar = scalar @_;
	return @unique;
}