#!/usr/bin/perl
#raxmlreader.pl
use warnings;
use strict;

#program is designed to just read raxml files and put into a csv format.

print "\n";
print "\t\t\tRunning perl version $^V\n" ;
print "\t\t\tProgram Developed by Ryan Christian\n";
print "\t\t\tOriginal coding: 1-31-2018\n";
print "\t\t\tLast Modified: 1-31-2018\n";
print "\n\n";	

		
print "Please input directory of files containing newick-formatted raxml files to read: \n"; 
my $directory = <STDIN>;
chomp $directory;
$directory =~ s/"|'//gi;

if (-d $directory) {
	print "Reading from directory $directory.\n";
}	else {
	print "$directory is not a directory! \n";
	die;
}
chdir $directory;
opendir(DIR, $directory) or die "couldn't open directory $directory for reading: $!\n";
my @files = readdir(DIR);
closedir(DIR);
my @raxes = grep(m/(.raxml$)/,@files);

print "Please input filename for output file:\n";
my $out = <STDIN>;
chomp $out;
open (OUT, ">", $out) or die "couldn't open file $out for writing:$!\n";

foreach my $rax (@raxes) {
	my $file = $rax;
	$file =~ s/RAxML_result.//gi;
	$file =~ s/RAxML_bestTree.//gi;
	$file =~ s/BLAST0.90_only-//gi;
	$file =~ s/Consensus-Robust-//gi;
	$file =~ s/UCLUST0.90-only-//gi;
	$file =~ s/-BLAST-filtered-40.fasta.1.raxml//gi;
	$file =~ s/_FullSeqs_UpdatedHeaders.fasta.1.raxml//gi;
	open (RAX, "<", $rax) or die "couldn't open file $rax for reading:$!\n";
	my @lines = (<RAX>);
	chomp @lines;
	close RAX;
	my $line = shift @lines;
	
	print OUT $file . "\t";
	print OUT $line . "\n";
}
