#!/usr/bin/perl
#textmerger.plx
use warnings;
use strict;

#program is designed to take a series of files and merge them with a common fasta file

	

		
print "Please input directory to merge with master fasta: \n";
my $directory = <STDIN>;
$directory =~ s/"//g;
chomp $directory;

chdir $directory;

opendir (DIR, $directory) or die "couldn't open directory $directory for reading: $!\n";
my @files = readdir(DIR);
closedir(DIR);
my @fastas = grep(m/.txt/, @files);

print "Please input common FASTA to merge with: \n";
my $file2 = <STDIN>;
$file2 =~ s/"//g;
chomp $file2;

open (COMMON, "<", $file2) or die "couldn't open fasta file $file2 for reading: $!\n";
my @common = <COMMON>;
close COMMON;
my %masterseqs;

my @mheaders = grep(/^>/, @common);
my @mseqs = grep(/^\w/, @common);
chomp @mheaders;
chomp @mseqs;
@masterseqs{@mheaders} = @mseqs;

my @sortedcommon = SORT (%masterseqs);

close COMMON;

foreach my $fasta (@fastas) {

	my $master = $fasta;
	$master =~ s/.txt/.fasta/;
	
	open (MASTER, ">", $master) or die "couldn't open mergefile $master for writing: $!\n";
	open (FASTA, "<", $fasta) or die "couldn't open fasta file $fasta for reading: $!\n";
	my @lines = <FASTA>;
	close FASTA;
	my %localseqs;
	my @fileheaders = grep(/^>/, @lines);
	my @fileseqs = grep(/^\w/, @lines);
	chomp @fileheaders;
	chomp @fileseqs;
	@lines = undef;
	
	@localseqs{@fileheaders} = @fileseqs;
	my @sortedlines = SORT(%localseqs);
	
	local $, =  "\n";
	print MASTER @sortedlines;
	print MASTER @sortedcommon;
	close MASTER;
}



#SORT subroutine joins header/seq and creates an array that is length-sorted. Splits back into header/fasta and returns split array.
sub SORT {

#pass hash of seedbatch master file into subroutine
	my %unsortedseqs = @_;
	my @sortedrand;
	foreach my $key (sort {length ($unsortedseqs{$b}) <=> length ($unsortedseqs{$a})} keys %unsortedseqs) {
		push @sortedrand, "$key", "$unsortedseqs{$key}";
	}
	return @sortedrand;	
}